summaryrefslogtreecommitdiff
path: root/src/share/common
blob: af346a80e02dd3110fb016f531e59e8bb4c047a7 (plain)
  1. # -*-shell-script-*-
  2. # This should be sourced by bash (though we welcome changes to make it POSIX sh compliant)
  3. # Shared sh functions for the monkeysphere
  4. #
  5. # Written by
  6. # Jameson Rollins <jrollins@finestructure.net>
  7. # Jamie McClelland <jm@mayfirst.org>
  8. # Daniel Kahn Gillmor <dkg@fifthhorseman.net>
  9. #
  10. # Copyright 2008-2009, released under the GPL, version 3 or later
  11. # all-caps variables are meant to be user supplied (ie. from config
  12. # file) and are considered global
  13. ########################################################################
  14. ### UTILITY FUNCTIONS
  15. # output version info
  16. version() {
  17. cat "${SYSSHAREDIR}/VERSION"
  18. }
  19. # failure function. exits with code 255, unless specified otherwise.
  20. failure() {
  21. [ "$1" ] && echo "$1" >&2
  22. exit ${2:-'255'}
  23. }
  24. # write output to stderr based on specified LOG_LEVEL the first
  25. # parameter is the priority of the output, and everything else is what
  26. # is echoed to stderr. If there is nothing else, then output comes
  27. # from stdin, and is not prefaced by log prefix.
  28. log() {
  29. local priority
  30. local level
  31. local output
  32. local alllevels
  33. local found=
  34. # don't include SILENT in alllevels: it's handled separately
  35. # list in decreasing verbosity (all caps).
  36. # separate with $IFS explicitly, since we do some fancy footwork
  37. # elsewhere.
  38. alllevels="DEBUG${IFS}VERBOSE${IFS}INFO${IFS}ERROR"
  39. # translate lowers to uppers in global log level
  40. LOG_LEVEL=$(echo "$LOG_LEVEL" | tr "[:lower:]" "[:upper:]")
  41. # just go ahead and return if the log level is silent
  42. if [ "$LOG_LEVEL" = 'SILENT' ] ; then
  43. return
  44. fi
  45. for level in $alllevels ; do
  46. if [ "$LOG_LEVEL" = "$level" ] ; then
  47. found=true
  48. fi
  49. done
  50. if [ -z "$found" ] ; then
  51. # default to INFO:
  52. LOG_LEVEL=INFO
  53. fi
  54. # get priority from first parameter, translating all lower to
  55. # uppers
  56. priority=$(echo "$1" | tr "[:lower:]" "[:upper:]")
  57. shift
  58. # scan over available levels
  59. for level in $alllevels ; do
  60. # output if the log level matches, set output to true
  61. # this will output for all subsequent loops as well.
  62. if [ "$LOG_LEVEL" = "$level" ] ; then
  63. output=true
  64. fi
  65. if [ "$priority" = "$level" -a "$output" = 'true' ] ; then
  66. if [ "$1" ] ; then
  67. echo "$@"
  68. else
  69. cat
  70. fi | sed 's/^/'"${LOG_PREFIX}"'/' >&2
  71. fi
  72. done
  73. }
  74. # run command as monkeysphere user
  75. su_monkeysphere_user() {
  76. # our main goal here is to run the given command as the the
  77. # monkeysphere user, but without prompting for any sort of
  78. # authentication. If this is not possible, we should just fail.
  79. # FIXME: our current implementation is overly restrictive, because
  80. # there may be some su PAM configurations that would allow su
  81. # "$MONKEYSPHERE_USER" -c "$@" to Just Work without prompting,
  82. # allowing specific users to invoke commands which make use of
  83. # this user.
  84. # chpst (from runit) would be nice to use, but we don't want to
  85. # introduce an extra dependency just for this. This may be a
  86. # candidate for re-factoring if we switch implementation languages.
  87. case $(id -un) in
  88. # if monkeysphere user, run the command under bash
  89. "$MONKEYSPHERE_USER")
  90. bash -c "$@"
  91. ;;
  92. # if root, su command as monkeysphere user
  93. 'root')
  94. su "$MONKEYSPHERE_USER" -c "$@"
  95. ;;
  96. # otherwise, fail
  97. *)
  98. log error "non-privileged user."
  99. ;;
  100. esac
  101. }
  102. # cut out all comments(#) and blank lines from standard input
  103. meat() {
  104. grep -v -e "^[[:space:]]*#" -e '^$' "$1"
  105. }
  106. # cut a specified line from standard input
  107. cutline() {
  108. head --line="$1" "$2" | tail -1
  109. }
  110. # make a temporary directory
  111. msmktempdir() {
  112. mktemp -d ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  113. }
  114. # make a temporary file
  115. msmktempfile() {
  116. mktemp ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  117. }
  118. # this is a wrapper for doing lock functions.
  119. #
  120. # it lets us depend on either lockfile-progs (preferred) or procmail's
  121. # lockfile, and should
  122. lock() {
  123. local use_lockfileprogs=true
  124. local action="$1"
  125. local file="$2"
  126. if ! ( type lockfile-create &>/dev/null ) ; then
  127. if ! ( type lockfile &>/dev/null ); then
  128. failure "Neither lockfile-create nor lockfile are in the path!"
  129. fi
  130. use_lockfileprogs=
  131. fi
  132. case "$action" in
  133. create)
  134. if [ -n "$use_lockfileprogs" ] ; then
  135. lockfile-create "$file" || failure "unable to lock '$file'"
  136. else
  137. lockfile -r 20 "${file}.lock" || failure "unable to lock '$file'"
  138. fi
  139. log debug "lock created on '$file'."
  140. ;;
  141. touch)
  142. if [ -n "$use_lockfileprogs" ] ; then
  143. lockfile-touch --oneshot "$file"
  144. else
  145. : Nothing to do here
  146. fi
  147. log debug "lock touched on '$file'."
  148. ;;
  149. remove)
  150. if [ -n "$use_lockfileprogs" ] ; then
  151. lockfile-remove "$file"
  152. else
  153. rm -f "${file}.lock"
  154. fi
  155. log debug "lock removed on '$file'."
  156. ;;
  157. *)
  158. failure "bad argument for lock subfunction '$action'"
  159. esac
  160. }
  161. # for portability, between gnu date and BSD date.
  162. # arguments should be: number longunits format
  163. # e.g. advance_date 20 seconds +%F
  164. advance_date() {
  165. local gnutry
  166. local number="$1"
  167. local longunits="$2"
  168. local format="$3"
  169. local shortunits
  170. # try things the GNU way first
  171. if date -d "$number $longunits" "$format" &>/dev/null; then
  172. date -d "$number $longunits" "$format"
  173. else
  174. # otherwise, convert to (a limited version of) BSD date syntax:
  175. case "$longunits" in
  176. years)
  177. shortunits=y
  178. ;;
  179. months)
  180. shortunits=m
  181. ;;
  182. weeks)
  183. shortunits=w
  184. ;;
  185. days)
  186. shortunits=d
  187. ;;
  188. hours)
  189. shortunits=H
  190. ;;
  191. minutes)
  192. shortunits=M
  193. ;;
  194. seconds)
  195. shortunits=S
  196. ;;
  197. *)
  198. # this is a longshot, and will likely fail; oh well.
  199. shortunits="$longunits"
  200. esac
  201. date "-v+${number}${shortunits}" "$format"
  202. fi
  203. }
  204. # check that characters are in a string (in an AND fashion).
  205. # used for checking key capability
  206. # check_capability capability a [b...]
  207. check_capability() {
  208. local usage
  209. local capcheck
  210. usage="$1"
  211. shift 1
  212. for capcheck ; do
  213. if echo "$usage" | grep -q -v "$capcheck" ; then
  214. return 1
  215. fi
  216. done
  217. return 0
  218. }
  219. # hash of a file
  220. file_hash() {
  221. if type md5sum &>/dev/null ; then
  222. md5sum "$1"
  223. elif type md5 &>/dev/null ; then
  224. md5 "$1"
  225. else
  226. failure "Neither md5sum nor md5 are in the path!"
  227. fi
  228. }
  229. # convert escaped characters in pipeline from gpg output back into
  230. # original character
  231. # FIXME: undo all escape character translation in with-colons gpg
  232. # output
  233. gpg_unescape() {
  234. sed 's/\\x3a/:/g'
  235. }
  236. # convert nasty chars into gpg-friendly form in pipeline
  237. # FIXME: escape everything, not just colons!
  238. gpg_escape() {
  239. sed 's/:/\\x3a/g'
  240. }
  241. # prompt for GPG-formatted expiration, and emit result on stdout
  242. get_gpg_expiration() {
  243. local keyExpire
  244. keyExpire="$1"
  245. if [ -z "$keyExpire" -a "$PROMPT" != 'false' ]; then
  246. cat >&2 <<EOF
  247. Please specify how long the key should be valid.
  248. 0 = key does not expire
  249. <n> = key expires in n days
  250. <n>w = key expires in n weeks
  251. <n>m = key expires in n months
  252. <n>y = key expires in n years
  253. EOF
  254. while [ -z "$keyExpire" ] ; do
  255. printf "Key is valid for? (0) " >&2
  256. read keyExpire
  257. if ! test_gpg_expire ${keyExpire:=0} ; then
  258. echo "invalid value" >&2
  259. unset keyExpire
  260. fi
  261. done
  262. elif ! test_gpg_expire "$keyExpire" ; then
  263. failure "invalid key expiration value '$keyExpire'."
  264. fi
  265. echo "$keyExpire"
  266. }
  267. passphrase_prompt() {
  268. local prompt="$1"
  269. local fifo="$2"
  270. local PASS
  271. if [ "$DISPLAY" ] && type "${SSH_ASKPASS:-ssh-askpass}" >/dev/null 2>/dev/null; then
  272. printf 'Launching "%s"\n' "${SSH_ASKPASS:-ssh-askpass}" | log info
  273. printf '(with prompt "%s")\n' "$prompt" | log debug
  274. "${SSH_ASKPASS:-ssh-askpass}" "$prompt" > "$fifo"
  275. else
  276. read -s -p "$prompt" PASS
  277. # Uses the builtin echo, so should not put the passphrase into
  278. # the process table. I think. --dkg
  279. echo "$PASS" > "$fifo"
  280. fi
  281. }
  282. # remove all lines with specified string from specified file
  283. remove_line() {
  284. local file
  285. local string
  286. local tempfile
  287. file="$1"
  288. string="$2"
  289. if [ -z "$file" -o -z "$string" ] ; then
  290. return 1
  291. fi
  292. if [ ! -e "$file" ] ; then
  293. return 1
  294. fi
  295. # if the string is in the file...
  296. if grep -q -F "$string" "$file" 2>/dev/null ; then
  297. tempfile=$(mktemp "${file}.XXXXXXX") || \
  298. failure "Unable to make temp file '${file}.XXXXXXX'"
  299. # remove the line with the string, and return 0
  300. grep -v -F "$string" "$file" >"$tempfile"
  301. cat "$tempfile" > "$file"
  302. rm "$tempfile"
  303. return 0
  304. # otherwise return 1
  305. else
  306. return 1
  307. fi
  308. }
  309. # remove all lines with MonkeySphere strings in file
  310. remove_monkeysphere_lines() {
  311. local file
  312. local tempfile
  313. file="$1"
  314. # return error if file does not exist
  315. if [ ! -e "$file" ] ; then
  316. return 1
  317. fi
  318. # just return ok if the file is empty, since there aren't any
  319. # lines to remove
  320. if [ ! -s "$file" ] ; then
  321. return 0
  322. fi
  323. tempfile=$(mktemp "${file}.XXXXXXX") || \
  324. failure "Could not make temporary file '${file}.XXXXXXX'."
  325. egrep -v '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$' \
  326. "$file" >"$tempfile"
  327. cat "$tempfile" > "$file"
  328. rm "$tempfile"
  329. }
  330. # translate ssh-style path variables %h and %u
  331. translate_ssh_variables() {
  332. local uname
  333. local home
  334. uname="$1"
  335. path="$2"
  336. # get the user's home directory
  337. userHome=$(get_homedir "$uname")
  338. # translate '%u' to user name
  339. path=${path/\%u/"$uname"}
  340. # translate '%h' to user home directory
  341. path=${path/\%h/"$userHome"}
  342. echo "$path"
  343. }
  344. # test that a string to conforms to GPG's expiration format
  345. test_gpg_expire() {
  346. echo "$1" | egrep -q "^[0-9]+[mwy]?$"
  347. }
  348. # check that a file is properly owned, and that all it's parent
  349. # directories are not group/other writable
  350. check_key_file_permissions() {
  351. local uname
  352. local path
  353. uname="$1"
  354. path="$2"
  355. if [ "$STRICT_MODES" = 'false' ] ; then
  356. log debug "skipping path permission check for '$path' because STRICT_MODES is false..."
  357. return 0
  358. fi
  359. log debug "checking path permission '$path'..."
  360. "${SYSSHAREDIR}/checkperms" "$uname" "$path"
  361. }
  362. # return a list of all users on the system
  363. list_users() {
  364. if type getent &>/dev/null ; then
  365. # for linux and FreeBSD systems
  366. getent passwd | cut -d: -f1
  367. elif type dscl &>/dev/null ; then
  368. # for Darwin systems
  369. dscl localhost -list /Search/Users
  370. else
  371. failure "Neither getent or dscl is in the path! Could not determine list of users."
  372. fi
  373. }
  374. # take one argument, a service name. in response, print a series of
  375. # lines, each with a unique numeric port number that might be
  376. # associated with that service name. (e.g. in: "https", out: "443")
  377. # if nothing is found, print nothing, and return 0.
  378. #
  379. # return 1 if there was an error in the search somehow
  380. get_port_for_service() {
  381. [[ "$1" =~ ^[a-z0-9]([a-z0-9-]*[a-z0-9])?$ ]] || \
  382. failure $(printf "This is not a valid service name: '%s'" "$1")
  383. if type getent &>/dev/null ; then
  384. # for linux and FreeBSD systems (getent returns 2 if not found, 0 on success, 1 or 3 on various failures)
  385. (getent services "$service" || if [ "$?" -eq 2 ] ; then true ; else false; fi) | awk '{ print $2 }' | cut -f1 -d/ | sort -u
  386. elif [ -r /etc/services ] ; then
  387. # fall back to /etc/services for systems that don't have getent (MacOS?)
  388. # FIXME: doesn't handle aliases like "null" (or "http"?), which don't show up at the beginning of the line.
  389. awk $(printf '/^%s[[:space:]]/{ print $2 }' "$1") /etc/services | cut -f1 -d/ | sort -u
  390. else
  391. return 1
  392. fi
  393. }
  394. # return the path to the home directory of a user
  395. get_homedir() {
  396. local uname=${1:-`whoami`}
  397. eval "echo ~${uname}"
  398. }
  399. # return the primary group of a user
  400. get_primary_group() {
  401. local uname=${1:-`whoami`}
  402. groups "$uname" | sed 's/^..* : //' | awk '{ print $1 }'
  403. }
  404. ### CONVERSION UTILITIES
  405. # output the ssh key for a given key ID
  406. gpg2ssh() {
  407. local keyID
  408. keyID="$1"
  409. gpg --export --no-armor "$keyID" | openpgp2ssh "$keyID" 2>/dev/null
  410. }
  411. # output known_hosts line from ssh key
  412. ssh2known_hosts() {
  413. local host
  414. local port
  415. local key
  416. # FIXME this does not properly deal with IPv6 hosts using the
  417. # standard port (because it's unclear whether their final
  418. # colon-delimited address section is a port number or an address
  419. # string)
  420. host=${1%:*}
  421. port=${1##*:}
  422. key="$2"
  423. # specify the host and port properly for new ssh known_hosts
  424. # format
  425. if [ "$port" != "$host" ] ; then
  426. host="[${host}]:${port}"
  427. fi
  428. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  429. }
  430. # output authorized_keys line from ssh key
  431. ssh2authorized_keys() {
  432. local userID
  433. local key
  434. userID="$1"
  435. key="$2"
  436. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  437. }
  438. # convert key from gpg to ssh known_hosts format
  439. gpg2known_hosts() {
  440. local host
  441. local keyID
  442. local key
  443. host="$1"
  444. keyID="$2"
  445. key=$(gpg2ssh "$keyID")
  446. # NOTE: it seems that ssh-keygen -R removes all comment fields from
  447. # all lines in the known_hosts file. why?
  448. # NOTE: just in case, the COMMENT can be matched with the
  449. # following regexp:
  450. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  451. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  452. }
  453. # convert key from gpg to ssh authorized_keys format
  454. gpg2authorized_keys() {
  455. local userID
  456. local keyID
  457. local key
  458. userID="$1"
  459. keyID="$2"
  460. key=$(gpg2ssh "$keyID")
  461. # NOTE: just in case, the COMMENT can be matched with the
  462. # following regexp:
  463. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  464. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  465. }
  466. ### GPG UTILITIES
  467. # script to determine if gpg version is equal to or greater than specified version
  468. is_gpg_version_greater_equal() {
  469. local gpgVersion=$(gpg --version | head -1 | awk '{ print $3 }')
  470. local latest=$(printf '%s\n%s\n' "$1" "$gpgVersion" \
  471. | tr '.' ' ' | sort -g -k1 -k2 -k3 \
  472. | tail -1 | tr ' ' '.')
  473. [[ "$gpgVersion" == "$latest" ]]
  474. }
  475. # retrieve all keys with given user id from keyserver
  476. # FIXME: need to figure out how to retrieve all matching keys
  477. # (not just first N (5 in this case))
  478. gpg_fetch_userid() {
  479. local returnCode=0
  480. local userID
  481. if [ "$CHECK_KEYSERVER" != 'true' ] ; then
  482. return 0
  483. fi
  484. userID="$1"
  485. log verbose " checking keyserver $KEYSERVER... "
  486. echo 1,2,3,4,5 | \
  487. gpg --quiet --batch --with-colons \
  488. --command-fd 0 --keyserver "$KEYSERVER" \
  489. --search ="$userID" &>/dev/null
  490. returnCode="$?"
  491. if [ "$returnCode" != 0 ] ; then
  492. log error "Failure ($returnCode) searching keyserver $KEYSERVER for user id '$userID'"
  493. fi
  494. return "$returnCode"
  495. }
  496. ########################################################################
  497. ### PROCESSING FUNCTIONS
  498. # userid and key policy checking
  499. # the following checks policy on the returned keys
  500. # - checks that full key has appropriate valididy (u|f)
  501. # - checks key has specified capability (REQUIRED_KEY_CAPABILITY)
  502. # - checks that requested user ID has appropriate validity
  503. # (see /usr/share/doc/gnupg/DETAILS.gz)
  504. # output is one line for every found key, in the following format:
  505. #
  506. # flag:sshKey
  507. #
  508. # "flag" is an acceptability flag, 0 = ok, 1 = bad
  509. # "sshKey" is the relevant OpenPGP key, in the form accepted by OpenSSH
  510. #
  511. # all log output must go to stderr, as stdout is used to pass the
  512. # flag:sshKey to the calling function.
  513. process_user_id() {
  514. local returnCode=0
  515. local userID
  516. local requiredCapability
  517. local requiredPubCapability
  518. local gpgOut
  519. local type
  520. local validity
  521. local keyid
  522. local uidfpr
  523. local usage
  524. local keyOK
  525. local uidOK
  526. local lastKey
  527. local lastKeyOK
  528. local fingerprint
  529. userID="$1"
  530. # set the required key capability based on the mode
  531. requiredCapability=${REQUIRED_KEY_CAPABILITY:="a"}
  532. requiredPubCapability=$(echo "$requiredCapability" | tr "[:lower:]" "[:upper:]")
  533. # fetch the user ID if necessary/requested
  534. gpg_fetch_userid "$userID"
  535. # output gpg info for (exact) userid and store
  536. gpgOut=$(gpg --list-key --fixed-list-mode --with-colon \
  537. --with-fingerprint --with-fingerprint \
  538. ="$userID" 2>/dev/null) || returnCode="$?"
  539. # if the gpg query return code is not 0, return 1
  540. if [ "$returnCode" -ne 0 ] ; then
  541. log verbose " no primary keys found."
  542. return 1
  543. fi
  544. # loop over all lines in the gpg output and process.
  545. echo "$gpgOut" | cut -d: -f1,2,5,10,12 | \
  546. while IFS=: read -r type validity keyid uidfpr usage ; do
  547. # process based on record type
  548. case $type in
  549. 'pub') # primary keys
  550. # new key, wipe the slate
  551. keyOK=
  552. uidOK=
  553. lastKey=pub
  554. lastKeyOK=
  555. fingerprint=
  556. log verbose " primary key found: $keyid"
  557. # if overall key is not valid, skip
  558. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  559. log debug " - unacceptable primary key validity ($validity)."
  560. continue
  561. fi
  562. # if overall key is disabled, skip
  563. if check_capability "$usage" 'D' ; then
  564. log debug " - key disabled."
  565. continue
  566. fi
  567. # if overall key capability is not ok, skip
  568. if ! check_capability "$usage" $requiredPubCapability ; then
  569. log debug " - unacceptable primary key capability ($usage)."
  570. continue
  571. fi
  572. # mark overall key as ok
  573. keyOK=true
  574. # mark primary key as ok if capability is ok
  575. if check_capability "$usage" $requiredCapability ; then
  576. lastKeyOK=true
  577. fi
  578. ;;
  579. 'uid') # user ids
  580. if [ "$lastKey" != pub ] ; then
  581. log verbose " ! got a user ID after a sub key?! user IDs should only follow primary keys!"
  582. continue
  583. fi
  584. # if an acceptable user ID was already found, skip
  585. if [ "$uidOK" = 'true' ] ; then
  586. continue
  587. fi
  588. # if the user ID does matches...
  589. if [ "$(echo "$uidfpr" | gpg_unescape)" = "$userID" ] ; then
  590. # and the user ID validity is ok
  591. if [ "$validity" = 'u' -o "$validity" = 'f' ] ; then
  592. # mark user ID acceptable
  593. uidOK=true
  594. else
  595. log debug " - unacceptable user ID validity ($validity)."
  596. fi
  597. else
  598. continue
  599. fi
  600. # output a line for the primary key
  601. # 0 = ok, 1 = bad
  602. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  603. log verbose " * acceptable primary key."
  604. if [ -z "$sshKey" ] ; then
  605. log verbose " ! primary key could not be translated (not RSA?)."
  606. else
  607. echo "0:${sshKey}"
  608. fi
  609. else
  610. log debug " - unacceptable primary key."
  611. if [ -z "$sshKey" ] ; then
  612. log debug " ! primary key could not be translated (not RSA?)."
  613. else
  614. echo "1:${sshKey}"
  615. fi
  616. fi
  617. ;;
  618. 'sub') # sub keys
  619. # unset acceptability of last key
  620. lastKey=sub
  621. lastKeyOK=
  622. fingerprint=
  623. # don't bother with sub keys if the primary key is not valid
  624. if [ "$keyOK" != true ] ; then
  625. continue
  626. fi
  627. # don't bother with sub keys if no user ID is acceptable:
  628. if [ "$uidOK" != true ] ; then
  629. continue
  630. fi
  631. # if sub key validity is not ok, skip
  632. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  633. log debug " - unacceptable sub key validity ($validity)."
  634. continue
  635. fi
  636. # if sub key capability is not ok, skip
  637. if ! check_capability "$usage" $requiredCapability ; then
  638. log debug " - unacceptable sub key capability ($usage)."
  639. continue
  640. fi
  641. # mark sub key as ok
  642. lastKeyOK=true
  643. ;;
  644. 'fpr') # key fingerprint
  645. fingerprint="$uidfpr"
  646. sshKey=$(gpg2ssh "$fingerprint")
  647. # if the last key was the pub key, skip
  648. if [ "$lastKey" = pub ] ; then
  649. continue
  650. fi
  651. # output a line for the sub key
  652. # 0 = ok, 1 = bad
  653. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  654. log verbose " * acceptable sub key."
  655. if [ -z "$sshKey" ] ; then
  656. log error " ! sub key could not be translated (not RSA?)."
  657. else
  658. echo "0:${sshKey}"
  659. fi
  660. else
  661. log debug " - unacceptable sub key."
  662. if [ -z "$sshKey" ] ; then
  663. log debug " ! sub key could not be translated (not RSA?)."
  664. else
  665. echo "1:${sshKey}"
  666. fi
  667. fi
  668. ;;
  669. esac
  670. done | sort -t: -k1 -n -r
  671. # NOTE: this last sort is important so that the "good" keys (key
  672. # flag '0') come last. This is so that they take precedence when
  673. # being processed in the key files over "bad" keys (key flag '1')
  674. }
  675. # output all valid keys for specified user ID literal
  676. keys_for_userid() {
  677. local userID
  678. local noKey=
  679. local nKeys
  680. local nKeysOK
  681. local ok
  682. local sshKey
  683. local tmpfile
  684. userID="$1"
  685. log verbose "processing: $userID"
  686. nKeys=0
  687. nKeysOK=0
  688. IFS=$'\n'
  689. for line in $(process_user_id "${userID}") ; do
  690. # note that key was found
  691. nKeys=$((nKeys+1))
  692. ok=$(echo "$line" | cut -d: -f1)
  693. sshKey=$(echo "$line" | cut -d: -f2)
  694. if [ -z "$sshKey" ] ; then
  695. continue
  696. fi
  697. # if key OK, output key to stdout
  698. if [ "$ok" -eq '0' ] ; then
  699. # note that key was found ok
  700. nKeysOK=$((nKeysOK+1))
  701. printf '%s\n' "$sshKey"
  702. fi
  703. done
  704. # if at least one key was found...
  705. if [ "$nKeys" -gt 0 ] ; then
  706. # if ok keys were found, return 0
  707. if [ "$nKeysOK" -gt 0 ] ; then
  708. return 0
  709. # else return 2
  710. else
  711. return 2
  712. fi
  713. # if no keys were found, return 1
  714. else
  715. return 1
  716. fi
  717. }
  718. # process a single host in the known_host file
  719. process_host_known_hosts() {
  720. local host
  721. local userID
  722. local noKey=
  723. local nKeys
  724. local nKeysOK
  725. local ok
  726. local sshKey
  727. local tmpfile
  728. # set the key processing mode
  729. export REQUIRED_KEY_CAPABILITY="$REQUIRED_HOST_KEY_CAPABILITY"
  730. host="$1"
  731. userID="ssh://${host}"
  732. log verbose "processing: $host"
  733. nKeys=0
  734. nKeysOK=0
  735. IFS=$'\n'
  736. for line in $(process_user_id "${userID}") ; do
  737. # note that key was found
  738. nKeys=$((nKeys+1))
  739. ok=$(echo "$line" | cut -d: -f1)
  740. sshKey=$(echo "$line" | cut -d: -f2)
  741. if [ -z "$sshKey" ] ; then
  742. continue
  743. fi
  744. # remove any old host key line, and note if removed nothing is
  745. # removed
  746. remove_line "$KNOWN_HOSTS" "$sshKey" || noKey=true
  747. # if key OK, add new host line
  748. if [ "$ok" -eq '0' ] ; then
  749. # note that key was found ok
  750. nKeysOK=$((nKeysOK+1))
  751. # hash if specified
  752. if [ "$HASH_KNOWN_HOSTS" = 'true' ] ; then
  753. if (type ssh-keygen >/dev/null) ; then
  754. # FIXME: this is really hackish cause ssh-keygen won't
  755. # hash from stdin to stdout
  756. tmpfile=$(mktemp ${TMPDIR:-/tmp}/tmp.XXXXXXXXXX)
  757. ssh2known_hosts "$host" "$sshKey" > "$tmpfile"
  758. ssh-keygen -H -f "$tmpfile" 2>/dev/null
  759. cat "$tmpfile" >> "$KNOWN_HOSTS"
  760. rm -f "$tmpfile" "${tmpfile}.old"
  761. else
  762. # FIXME: we could do this without needing ssh-keygen. hashed
  763. # known_hosts looks like: |1|X|Y where 1 means SHA1 (nothing
  764. # else is defined in openssh sources), X is the salt (same
  765. # length as the digest output), base64-encoded, and Y is the
  766. # digested hostname (also base64-encoded).
  767. # see hostfile.{c,h} in openssh sources.
  768. failure "Cannot hash known_hosts as requested"
  769. fi
  770. else
  771. ssh2known_hosts "$host" "$sshKey" >> "$KNOWN_HOSTS"
  772. fi
  773. # log if this is a new key to the known_hosts file
  774. if [ "$noKey" ] ; then
  775. log info "* new key for $host added to known_hosts file."
  776. fi
  777. fi
  778. done
  779. # if at least one key was found...
  780. if [ "$nKeys" -gt 0 ] ; then
  781. # if ok keys were found, return 0
  782. if [ "$nKeysOK" -gt 0 ] ; then
  783. return 0
  784. # else return 2
  785. else
  786. return 2
  787. fi
  788. # if no keys were found, return 1
  789. else
  790. return 1
  791. fi
  792. }
  793. # update the known_hosts file for a set of hosts listed on command
  794. # line
  795. update_known_hosts() {
  796. local returnCode=0
  797. local nHosts
  798. local nHostsOK
  799. local nHostsBAD
  800. local fileCheck
  801. local host
  802. local newUmask
  803. # the number of hosts specified on command line
  804. nHosts="$#"
  805. nHostsOK=0
  806. nHostsBAD=0
  807. # touch the known_hosts file so that the file permission check
  808. # below won't fail upon not finding the file
  809. if [ ! -f "$KNOWN_HOSTS" ]; then
  810. # make sure to create any files or directories with the appropriate write bits turned off:
  811. newUmask=$(printf "%04o" $(( 0$(umask) | 0022 )) )
  812. [ -d $(dirname "$KNOWN_HOSTS") ] \
  813. || (umask "$newUmask" && mkdir -p -m 0700 $(dirname "$KNOWN_HOSTS") ) \
  814. || failure "Could not create path to known_hosts file '$KNOWN_HOSTS'"
  815. # make sure to create this file with the appropriate bits turned off:
  816. (umask "$newUmask" && touch "$KNOWN_HOSTS") \
  817. || failure "Unable to create known_hosts file '$KNOWN_HOSTS'"
  818. fi
  819. # check permissions on the known_hosts file path
  820. check_key_file_permissions $(whoami) "$KNOWN_HOSTS" \
  821. || failure "Bad permissions governing known_hosts file '$KNOWN_HOSTS'"
  822. # create a lockfile on known_hosts:
  823. lock create "$KNOWN_HOSTS"
  824. # FIXME: we're discarding any pre-existing EXIT trap; is this bad?
  825. trap "lock remove $KNOWN_HOSTS" EXIT
  826. # note pre update file checksum
  827. fileCheck=$(file_hash "$KNOWN_HOSTS")
  828. for host ; do
  829. # process the host
  830. process_host_known_hosts "$host" || returnCode="$?"
  831. # note the result
  832. case "$returnCode" in
  833. 0)
  834. nHostsOK=$((nHostsOK+1))
  835. ;;
  836. 2)
  837. nHostsBAD=$((nHostsBAD+1))
  838. ;;
  839. esac
  840. # touch the lockfile, for good measure.
  841. lock touch "$KNOWN_HOSTS"
  842. done
  843. # remove the lockfile and the trap
  844. lock remove "$KNOWN_HOSTS"
  845. trap - EXIT
  846. # note if the known_hosts file was updated
  847. if [ "$(file_hash "$KNOWN_HOSTS")" != "$fileCheck" ] ; then
  848. log debug "known_hosts file updated."
  849. fi
  850. # if an acceptable host was found, return 0
  851. if [ "$nHostsOK" -gt 0 ] ; then
  852. return 0
  853. # else if no ok hosts were found...
  854. else
  855. # if no bad host were found then no hosts were found at all,
  856. # and return 1
  857. if [ "$nHostsBAD" -eq 0 ] ; then
  858. return 1
  859. # else if at least one bad host was found, return 2
  860. else
  861. return 2
  862. fi
  863. fi
  864. }
  865. # process hosts from a known_hosts file
  866. process_known_hosts() {
  867. local hosts
  868. # exit if the known_hosts file does not exist
  869. if [ ! -e "$KNOWN_HOSTS" ] ; then
  870. failure "known_hosts file '$KNOWN_HOSTS' does not exist."
  871. fi
  872. log debug "processing known_hosts file:"
  873. log debug " $KNOWN_HOSTS"
  874. hosts=$(meat "$KNOWN_HOSTS" | cut -d ' ' -f 1 | grep -v '^|.*$' | tr , ' ' | tr '\n' ' ')
  875. if [ -z "$hosts" ] ; then
  876. log debug "no hosts to process."
  877. return
  878. fi
  879. # take all the hosts from the known_hosts file (first
  880. # field), grep out all the hashed hosts (lines starting
  881. # with '|')...
  882. update_known_hosts $hosts
  883. }
  884. # process uids for the authorized_keys file
  885. process_uid_authorized_keys() {
  886. local userID
  887. local nKeys
  888. local nKeysOK
  889. local ok
  890. local sshKey
  891. # set the key processing mode
  892. export REQUIRED_KEY_CAPABILITY="$REQUIRED_USER_KEY_CAPABILITY"
  893. userID="$1"
  894. log verbose "processing: $userID"
  895. nKeys=0
  896. nKeysOK=0
  897. IFS=$'\n'
  898. for line in $(process_user_id "$userID") ; do
  899. # note that key was found
  900. nKeys=$((nKeys+1))
  901. ok=$(echo "$line" | cut -d: -f1)
  902. sshKey=$(echo "$line" | cut -d: -f2)
  903. if [ -z "$sshKey" ] ; then
  904. continue
  905. fi
  906. # remove the old host key line
  907. remove_line "$AUTHORIZED_KEYS" "$sshKey"
  908. # if key OK, add new host line
  909. if [ "$ok" -eq '0' ] ; then
  910. # note that key was found ok
  911. nKeysOK=$((nKeysOK+1))
  912. ssh2authorized_keys "$userID" "$sshKey" >> "$AUTHORIZED_KEYS"
  913. fi
  914. done
  915. # if at least one key was found...
  916. if [ "$nKeys" -gt 0 ] ; then
  917. # if ok keys were found, return 0
  918. if [ "$nKeysOK" -gt 0 ] ; then
  919. return 0
  920. # else return 2
  921. else
  922. return 2
  923. fi
  924. # if no keys were found, return 1
  925. else
  926. return 1
  927. fi
  928. }
  929. # update the authorized_keys files from a list of user IDs on command
  930. # line
  931. update_authorized_keys() {
  932. local returnCode=0
  933. local userID
  934. local nIDs
  935. local nIDsOK
  936. local nIDsBAD
  937. local fileCheck
  938. # the number of ids specified on command line
  939. nIDs="$#"
  940. nIDsOK=0
  941. nIDsBAD=0
  942. log debug "updating authorized_keys file:"
  943. log debug " $AUTHORIZED_KEYS"
  944. # check permissions on the authorized_keys file path
  945. check_key_file_permissions $(whoami) "$AUTHORIZED_KEYS" || failure
  946. # create a lockfile on authorized_keys
  947. lock create "$AUTHORIZED_KEYS"
  948. # FIXME: we're discarding any pre-existing EXIT trap; is this bad?
  949. trap "lock remove $AUTHORIZED_KEYS" EXIT
  950. # note pre update file checksum
  951. fileCheck="$(file_hash "$AUTHORIZED_KEYS")"
  952. # remove any monkeysphere lines from authorized_keys file
  953. remove_monkeysphere_lines "$AUTHORIZED_KEYS"
  954. for userID ; do
  955. # process the user ID, change return code if key not found for
  956. # user ID
  957. process_uid_authorized_keys "$userID" || returnCode="$?"
  958. # note the result
  959. case "$returnCode" in
  960. 0)
  961. nIDsOK=$((nIDsOK+1))
  962. ;;
  963. 2)
  964. nIDsBAD=$((nIDsBAD+1))
  965. ;;
  966. esac
  967. # touch the lockfile, for good measure.
  968. lock touch "$AUTHORIZED_KEYS"
  969. done
  970. # remove the lockfile and the trap
  971. lock remove "$AUTHORIZED_KEYS"
  972. # remove the trap
  973. trap - EXIT
  974. # note if the authorized_keys file was updated
  975. if [ "$(file_hash "$AUTHORIZED_KEYS")" != "$fileCheck" ] ; then
  976. log debug "authorized_keys file updated."
  977. fi
  978. # if an acceptable id was found, return 0
  979. if [ "$nIDsOK" -gt 0 ] ; then
  980. return 0
  981. # else if no ok ids were found...
  982. else
  983. # if no bad ids were found then no ids were found at all, and
  984. # return 1
  985. if [ "$nIDsBAD" -eq 0 ] ; then
  986. return 1
  987. # else if at least one bad id was found, return 2
  988. else
  989. return 2
  990. fi
  991. fi
  992. }
  993. # process an authorized_user_ids file for authorized_keys
  994. process_authorized_user_ids() {
  995. local line
  996. local nline
  997. local userIDs
  998. authorizedUserIDs="$1"
  999. # exit if the authorized_user_ids file is empty
  1000. if [ ! -e "$authorizedUserIDs" ] ; then
  1001. failure "authorized_user_ids file '$authorizedUserIDs' does not exist."
  1002. fi
  1003. log debug "processing authorized_user_ids file:"
  1004. log debug " $authorizedUserIDs"
  1005. # check permissions on the authorized_user_ids file path
  1006. check_key_file_permissions $(whoami) "$authorizedUserIDs" || failure
  1007. if ! meat "$authorizedUserIDs" >/dev/null ; then
  1008. log debug " no user IDs to process."
  1009. return
  1010. fi
  1011. nline=0
  1012. # extract user IDs from authorized_user_ids file
  1013. IFS=$'\n'
  1014. for line in $(meat "$authorizedUserIDs") ; do
  1015. userIDs["$nline"]="$line"
  1016. nline=$((nline+1))
  1017. done
  1018. update_authorized_keys "${userIDs[@]}"
  1019. }
  1020. # takes a gpg key or keys on stdin, and outputs a list of
  1021. # fingerprints, one per line:
  1022. list_primary_fingerprints() {
  1023. local fake=$(msmktempdir)
  1024. trap "rm -rf $fake" EXIT
  1025. GNUPGHOME="$fake" gpg --no-tty --quiet --import --ignore-time-conflict 2>/dev/null
  1026. GNUPGHOME="$fake" gpg --with-colons --fingerprint --list-keys | \
  1027. awk -F: '/^fpr:/{ print $10 }'
  1028. trap - EXIT
  1029. rm -rf "$fake"
  1030. }
  1031. # takes an OpenPGP key or set of keys on stdin, a fingerprint or other
  1032. # key identifier as $1, and outputs the gpg-formatted information for
  1033. # the requested keys from the material on stdin
  1034. get_cert_info() {
  1035. local fake=$(msmktempdir)
  1036. trap "rm -rf $fake" EXIT
  1037. GNUPGHOME="$fake" gpg --no-tty --quiet --import --ignore-time-conflict 2>/dev/null
  1038. GNUPGHOME="$fake" gpg --with-colons --fingerprint --fixed-list-mode --list-keys "$1"
  1039. trap - EXIT
  1040. rm -rf "$fake"
  1041. }
  1042. check_cruft_file() {
  1043. local loc="$1"
  1044. local version="$2"
  1045. if [ -e "$loc" ] ; then
  1046. printf "! The file '%s' is no longer used by\n monkeysphere (as of version %s), and can be removed.\n\n" "$loc" "$version" | log info
  1047. fi
  1048. }
  1049. check_upgrade_dir() {
  1050. local loc="$1"
  1051. local version="$2"
  1052. if [ -d "$loc" ] ; then
  1053. printf "The presence of directory '%s' indicates that you have\nnot yet completed a monkeysphere upgrade.\nYou should probably run the following script:\n %s/transitions/%s\n\n" "$loc" "$SYSSHAREDIR" "$version" | log info
  1054. fi
  1055. }
  1056. ## look for cruft from old versions of the monkeysphere, and notice if
  1057. ## upgrades have not been run:
  1058. report_cruft() {
  1059. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-host" 0.23
  1060. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-authentication" 0.23
  1061. check_cruft_file "${SYSCONFIGDIR}/gnupg-authentication.conf" 0.23
  1062. check_cruft_file "${SYSCONFIGDIR}/gnupg-host.conf" 0.23
  1063. local found=
  1064. for foo in "${SYSDATADIR}/backup-from-"*"-transition" ; do
  1065. if [ -d "$foo" ] ; then
  1066. printf "! %s\n" "$foo" | log info
  1067. found=true
  1068. fi
  1069. done
  1070. if [ "$found" ] ; then
  1071. printf "The directories above are backups left over from a monkeysphere transition.\nThey may contain copies of sensitive data (host keys, certifier lists), but\nthey are no longer needed by monkeysphere.\nYou may remove them at any time.\n\n" | log info
  1072. fi
  1073. }